open List;;

(* implementazione del tipo di dato 't seq *)
type 't seq = 't list;; (* sequenze polimorfe implementate con liste *)

(* operazioni di 't seq richieste in QuickSort *)
let (size:'t seq ->int) = 
			(* Out: numero di elementi 't contenuti in seq *)
			(* effect: nessuna modifica                    *)
		fun x -> length x
;;
let (pivot:'t seq -> ('t * 't seq)) = 
			(* Out: coppia (ElementoSelezionato,SequenzaRimanente) per seq *)
			(* effect: nessuna modifica                                    *)
		fun x -> (hd x,tl x)
;;
let (dividi: 't seq -> ('t -> 't -> bool) -> 't -> ('t seq * 't seq)) = 
			(* Out: partiziona seq (rispetto a pv, con ordine op) in una *)
			(*         coppia (MinoriUguali,Maggiori) *)
			(* effect: nessuna modifica               *)
		fun seq op pv -> partition (fun x -> (op x pv)or(x = pv)) seq
;; 
let (concatena: 't seq -> 't seq -> 't seq) = 
			(* Out: concatena seq1 con seq2 *)
			(* effect: nessuna modifica     *)
		fun x y -> x@y
;;
let (cons: 't -> 't seq -> 't seq) = 
			(* Out: aggiunge x in testa ad xs *)
			(* effect: nessuna modifica       *)
		fun x xs -> x::xs
;;

